<script setup lang="ts">
import { ref } from "vue"
import { automationsStore } from "../stores/automations"

const { id } = defineProps<{ id: string }>()

const router = useRouter()

const store = automationsStore()

const newList: any = ref([])
const name: any = ref("")
const error: any = ref("")

const triggerTypes = ["button"]
const actionTypes = ["apiCall", "popup"]

onMounted(() => {
  const automation = store.automations[id] || {}

  name.value = automation.name || ""
  newList.value = automation.process || []
})

const orderedList = computed(() => {
  return newList.value.sort(
    (itemA: { order: number }, itemB: { order: number }) =>
      itemA.order - itemB.order,
  )
})

function generateId() {
  return `id-${Math.random().toString(36).substr(2, 9)}-${Date.now().toString(
    36,
  )}`
}

function computeAttribute(id: string, attribute: string) {
  const options
    = newList.value.find((item: any) => item.id === id)?.options || {}

  return options[attribute] || ""
}

function changeAttribute(id: string, attribute: string, event: any) {
  newList.value = newList.value.map((item: { id: string; options: any }) => {
    if (item.id !== id)
      return item
    return {
      ...item,
      options: {
        ...(item?.options || {}),
        [attribute]: event.target.value,
      },
    }
  })
}

function movePrioritySetting(id: string, direction: string) {
  const itemIndex = orderedList.value.findIndex((item: any) => item.id === id)
  const oldOrder = newList.value[itemIndex].order
  if (direction === "up") {
    if (itemIndex <= 0)
      return
    orderedList.value[itemIndex - 1].order = oldOrder
    orderedList.value[itemIndex].order = oldOrder - 1
  } else {
    if (itemIndex >= orderedList.value.length - 1)
      return
    orderedList.value[itemIndex + 1].order = oldOrder
    orderedList.value[itemIndex].order = oldOrder + 1
  }
}

function addItem(type: string) {
  const id = generateId()

  const newWorkflowItem = {
    id,
    type,
    order: newList.value.length + 1,
    ...(type === "trigger" ? { triggerType: "button" } : { actionType: "apiCall" }),
  }

  newList.value = [...newList.value, newWorkflowItem]
}

function deleteItem(id: string) {
  newList.value = newList.value.filter((item: any) => item.id !== id)
}

function validateSchema() {
  if (!newList.value.length) {
    error.value = "workflow is empty "
    return false
  }
  if (!name.value) {
    error.value = "you need to add a name "
    return false
  }
  return true
}

function save() {
  const id = generateId()
  if (!validateSchema())
    return

  store.addAutomations({ id, name, process: newList.value })
  newList.value = []
  router.push({ name: "automations" })
}
function update() {
  if (!validateSchema())
    return

  store.updateAutomation({ id, name, process: newList.value }, id)
  newList.value = []
  router.push({ name: "automations" })
}
</script>

<template>
  <div>
    <div class="flex mt-4">
      <input v-model="name" placeholder="name">
      <button
        class="hover:bg-green-200 border border-green-500 text-green-500 ml-auto p-2 rounded"
        @click="addItem('trigger')"
      >
        + Trigger
      </button>
      <button
        class="hover:bg-green-200 border border-green-500 text-green-500 mx-4 p-2 rounded"
        @click="addItem('action')"
      >
        + Action
      </button>
    </div>
    <div
      v-for="(workflowItem, idx) in orderedList"

      :key="`workflow-item-${idx}`"
      class="flex m-6"
    >
      <div class="flex mx-2">
        <button
          v-if="idx > 0"
          class="hover:bg-green-200 border border-green-500 text-green-500 mr-2 p-2 rounded mx-0"
          @click="movePrioritySetting(workflowItem.id, 'up')"
        >
          up
        </button>
        <button
          v-if="idx + 1 < newList.length"
          class="hover:bg-green-200 border border-green-500 text-green-500  p-2 rounded mx-0"
          @click="movePrioritySetting(workflowItem.id, 'down')"
        >
          down
        </button>
      </div>

      {{ `${workflowItem.order} - ${workflowItem.type} type: ` }}
      <div v-if="workflowItem.type === 'trigger'">
        <select v-model="workflowItem.triggerType" class="border p-1">
          <option
            v-for="(trigger, t_idx) in triggerTypes"
            :key="`workflow-item-${t_idx}`"
          >
            {{ trigger }}
          </option>
        </select>
      </div>

      <div v-if="workflowItem.type === 'action'" class="flex">
        <select v-model="workflowItem.actionType" class="border p-1">
          <option
            v-for="(action, a_idx) in actionTypes"
            :key="`workflow-item-${a_idx}`"
          >
            {{ action }}
          </option>
        </select>
        <div v-if="workflowItem.actionType === 'apiCall'" class="flex ml-2">
          <input
            placeholder="url"
            :value="computeAttribute(workflowItem.id, 'url')"
            @change="(event) => changeAttribute(workflowItem.id, 'url', event)"
          >
          <input
            placeholder="parameters"
            :value="computeAttribute(workflowItem.id, 'parameters')"
            @change="
              (event) => changeAttribute(workflowItem.id, 'parameters', event)
            "
          >
        </div>
      </div>

      <button
        class="text-red border border-red ml-auto p-2 rounded"
        @click="deleteItem(workflowItem.id)"
      >
        X
      </button>
    </div>
    <div class="flex m-6">
      <p class="text-red">
        {{ error }}
      </p>
      <button
        v-if="id === 'new'"
        class="bg-green-500 hover:bg-green-700 text-white ml-auto p-2 rounded"
        @click="save()"
      >
        Save
      </button>
      <button
        v-else
        class="bg-green-500 hover:bg-green-700 text-white ml-auto p-2 rounded"
        @click="update()"
      >
        Update
      </button>
    </div>
  </div>
</template>
